# Management Commands

## Purge expired snippets
---

Snippets are removed as soon as they exceed their expiration date and get fetched by a client, however if they never get fetched this isn’t triggered. dpaste ships with a management command `cleanup_snippets` that removes these expired snippets.

It’s sufficient to run it daily.

To run it locally do:

```bash
$ pipenv run ./managepy cleanup_snippets
```

### Options
**`--dry-run`**

    Does not actually delete the snippets. This is useful for local testing.

### Setup a Crontab

A crontab line might look like:

```c
1 20 * * * /srv/dpaste.org/pipenv run manage.py cleanup_snippets > /dev/null
```

!!! note "Note"

        If you use the *database* session backend, you may also need to setup a crontab that removes the expired entries from the session database.
        
        See the related [Django Documentation](https://docs.djangoproject.com/en/2.0/ref/django-admin/#django-admin-clearsessions) for details.
